/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    : adslAturPerfDataTable_access.h
 * Author       : Subbi
 * Date         : 17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      : Amazon
 * Block        : ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains:
 *                 1) User-defined data structure for accessing
 *                    adslAturPerfDataTable
 *                 2) User-defined data access functions for data in table
 *                    adslAturPerfDataTable
 *                 3) Column accessors functions
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */


/* ===========================================================================
 * Revision History:
 * subramani: Changed the return types for get_adslAturPerfValidIntervals,
 * get_adslAturPerfInvalidIntervals and get_adslAturPerfPrev1DayMoniSecs
 * $Log$
 * ===========================================================================
 */


/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

#ifndef ADSLATURPERFDATATABLE_ACCESS_H
#define ADSLATURPERFDATATABLE_ACCESS_H

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
 */
#include <adslMIB/adslTable_access.h>

/*
 * ===========================================================================
 *                           USER-DEFINED DATA TYPES
 * ===========================================================================
 */

#ifdef STUB_IOCTL
/** User-defined data structure for accessing adslAturPerfDataTable **/
#define AdslPerfTimeElapsed u_int32
#define PerfCurrentCount u_int32
#define AdslPerfCurrDayCount u_int32
#define AdslPerfPrevDayCount u_int32

typedef struct aturPerfDataEntry
{
   int          ifIndex;
   u_int32          adslAturPerfLofs;
   u_int32          adslAturPerfLoss;
   u_int32          adslAturPerfLprs;
   u_int32          adslAturPerfESs;
   int              adslAturPerfValidIntervals;
   int              adslAturPerfInvalidIntervals;
   AdslPerfTimeElapsed  adslAturPerfCurr15MinTimeElapsed;
   PerfCurrentCount     adslAturPerfCurr15MinLofs;
   PerfCurrentCount     adslAturPerfCurr15MinLoss;
   PerfCurrentCount     adslAturPerfCurr15MinLprs;
   PerfCurrentCount     adslAturPerfCurr15MinESs;
   AdslPerfTimeElapsed  adslAturPerfCurr1DayTimeElapsed;
   AdslPerfCurrDayCount adslAturPerfCurr1DayLofs;
   AdslPerfCurrDayCount adslAturPerfCurr1DayLoss;
   AdslPerfCurrDayCount adslAturPerfCurr1DayLprs;
   AdslPerfCurrDayCount adslAturPerfCurr1DayESs;
   int              adslAturPerfPrev1DayMoniSecs;
   AdslPerfPrevDayCount adslAturPerfPrev1DayLofs;
   AdslPerfPrevDayCount adslAturPerfPrev1DayLoss;
   AdslPerfPrevDayCount adslAturPerfPrev1DayLprs;
   AdslPerfPrevDayCount adslAturPerfPrev1DayESs;
   u_int32          flags;
} aturPerfDataEntry;
#endif
/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
 */

/* User-defined data access functions for data in table adslAturPerfDataTable */
/** row level accessors */
Netsnmp_First_Data_Point adslAturPerfDataTable_get_first_data_point;
Netsnmp_Next_Data_Point adslAturPerfDataTable_get_next_data_point;


/** column accessors */
#if defined(HAVE_OPTIMIZED_CODE)
u_int32  *
get_adslAturPerfDataLoss(void *data_context, size_t * ret_len,
			unsigned int var);


int *
get_adslAturPerfIntervalData(void *data_context, size_t * ret_len,
			unsigned int var);

u_int32  *
get_adslAturPerfDataStats(void *data_context, size_t * ret_len,
			unsigned int var);
#else
u_int32  *get_adslAturPerfLofs(void *data_context, size_t * ret_len);
u_int32  *get_adslAturPerfLoss(void *data_context, size_t * ret_len);
u_int32  *get_adslAturPerfLprs(void *data_context, size_t * ret_len);
u_int32  *get_adslAturPerfESs(void *data_context, size_t * ret_len);
int     *get_adslAturPerfValidIntervals(void *data_context, size_t * ret_len);
int     *get_adslAturPerfInvalidIntervals(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAturPerfCurr15MinTimeElapsed(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAturPerfCurr15MinLofs(void *data_context, size_t * ret_len);
u_int32  *get_adslAturPerfCurr15MinLoss(void *data_context, size_t * ret_len);
u_int32  *get_adslAturPerfCurr15MinLprs(void *data_context, size_t * ret_len);
u_int32  *get_adslAturPerfCurr15MinESs(void *data_context, size_t * ret_len);
u_int32  *get_adslAturPerfCurr1DayTimeElapsed(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAturPerfCurr1DayLofs(void *data_context, size_t * ret_len);
u_int32  *get_adslAturPerfCurr1DayLoss(void *data_context, size_t * ret_len);
u_int32  *get_adslAturPerfCurr1DayLprs(void *data_context, size_t * ret_len);
u_int32  *get_adslAturPerfCurr1DayESs(void *data_context, size_t * ret_len);
int     *get_adslAturPerfPrev1DayMoniSecs(void *data_context,
            size_t * ret_len);
u_int32  *get_adslAturPerfPrev1DayLofs(void *data_context, size_t * ret_len);
u_int32  *get_adslAturPerfPrev1DayLoss(void *data_context, size_t * ret_len);
u_int32  *get_adslAturPerfPrev1DayLprs(void *data_context, size_t * ret_len);
u_int32  *get_adslAturPerfPrev1DayESs(void *data_context, size_t * ret_len);
#endif


#ifndef ENABLE_DRIVER_CALL
int get_adslAturPerfDataTable(int Fd2,int GET_adsl_ATUR_PERF_DATA2,
        void *atucPerfDataValue);
#endif

#endif                          /* ADSLATURPERFDATATABLE_ACCESS_H */
