/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    : adslAturPhysTable_access.c
 * Author       : Subbi
 * Date         : 17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      : Amazon
 * Block        : ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains functions for:
 *                 1) Getting the data context pointer & loop context pointer
 *                 2) User-defined data access functions (per column) for data
 *                    in table adslAturPhysTable
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */

/* ===========================================================================
 * Revision History:
 * Subramani: Changes made to return types of get_adslAturCurrSnrMgn
 * get_adslAturCurrStatus and get_adslAturCurrOutputPwr
 * $Log$
 * ===========================================================================
 */

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
 */
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

#include "adslAturPhysTable_access.h"
#include "adslAturPhysTable_enums.h"

/* column number definitions for table adslAturPhysTable */
#include "adslAturPhysTable_columns.h"

/*
 * ===========================================================================
 *                           GLOBAL DEFINITIONS
 * ===========================================================================
 */
// *** Global variable definitions
static long long_ret;
static char sys_info[32]= "";

/*
 * ===========================================================================
 *                           LOCAL FUNCTIONS
 * ===========================================================================
 */

/** returns the first data point within the adslAturPhysTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
adslAturPhysTable_get_first_data_point(void **my_loop_context,
                                       void **my_data_context,
                                       netsnmp_variable_list *
                                       put_index_data,
                                       netsnmp_iterator_info *mydata)
{

    int *My_Data_Context;
    My_Data_Context = SNMP_MALLOC_TYPEDEF(int);
    if (!My_Data_Context) {
        put_index_data = NULL;
        snmp_log(LOG_ERR, "Get-First: adslAturPhysTable: My_Data_Context malloc failed\n");
        return put_index_data;
    }

    *My_Data_Context=IFTYPE_ADSL;
    *my_data_context=My_Data_Context;

    put_index_data = adslTable_get_first_data_point(my_loop_context,
                                   my_data_context,
                                   put_index_data,
                                   mydata);

    SNMP_FREE(My_Data_Context);
    return put_index_data;
}

/** functionally the same as adslAturPhysTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
adslAturPhysTable_get_next_data_point(void **my_loop_context,
                                      void **my_data_context,
                                      netsnmp_variable_list *
                                      put_index_data,
                                      netsnmp_iterator_info *mydata)
{

    int *My_Data_Context;
    My_Data_Context = SNMP_MALLOC_TYPEDEF(int);
    if (!My_Data_Context) {
        put_index_data = NULL;
        snmp_log(LOG_ERR, "Get-Next: adslAturPhysTable: My_Data_Context malloc failed\n");
        return put_index_data;
    }
    *My_Data_Context=IFTYPE_ADSL;
    *my_data_context=My_Data_Context;

     put_index_data = adslTable_get_next_data_point(my_loop_context,
                                   my_data_context,
                                   put_index_data,
                                   mydata);

    SNMP_FREE(My_Data_Context);
    return put_index_data;
}


/*
 * User-defined data access functions (per column) for data in table
 * adslAturPhysTable */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */

#if defined(HAVE_OPTIMIZED_CODE)

char  *
get_adslAturInvData(void *data_context, size_t * ret_len,
			unsigned int var)
{
  unsigned int flags = 0;
  struct adslAturPhysEntry adslAturPhysStruct;
  memset(&adslAturPhysStruct,0,sizeof(adslAturPhysEntry));
  memset(sys_info,0,sizeof(sys_info));
  adslAturPhysStruct.ifIndex= (*(int *)data_context);

  switch (var) {

        case COLUMN_ADSLATURINVSERIALNUMBER:
	   flags = ATUR_PHY_SER_NUM_FLAG;
	   break;

        case COLUMN_ADSLATURINVVENDORID:
	   flags = ATUR_PHY_VENDOR_ID_FLAG;
	   break;

        case COLUMN_ADSLATURINVVERSIONNUMBER:
	   flags = ATUR_PHY_VER_NUM_FLAG;
	   break;

     	default:
     	   DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
     	   return NULL;
  	}
  
    SET_FLAG(&adslAturPhysStruct.flags, flags);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#else
    get_adslAturPhysTable1(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#endif
    if (IS_FLAG_SET(&adslAturPhysStruct.flags, flags) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "PhysTable: GET- %x CMV fail\n", flags));
    
    switch (flags)  {
	    
	case ATUR_PHY_SER_NUM_FLAG:
    	   strcpy(sys_info,adslAturPhysStruct.serial_no);
    	   *ret_len = strlen(adslAturPhysStruct.serial_no);
	   break;

	case ATUR_PHY_VENDOR_ID_FLAG:
    	   strcpy(sys_info,adslAturPhysStruct.vendor_id);
           *ret_len = strlen(adslAturPhysStruct.vendor_id);
	   break;

	case ATUR_PHY_VER_NUM_FLAG:
    	   strcpy(sys_info,adslAturPhysStruct.version_no);
           *ret_len = strlen(adslAturPhysStruct.version_no);
	   break;
	   
        default:
     	   DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
           return NULL;
	}

    CLR_FLAG(&adslAturPhysStruct.flags, flags);
    return (char *) sys_info;
}


int *
get_adslAturCurrSNROutputPwr(void *data_context, size_t *ret_len,
				unsigned int var)
{
  unsigned int flags = 0;
  struct adslAturPhysEntry adslAturPhysStruct;
  memset(&adslAturPhysStruct,0,sizeof(adslAturPhysEntry));
  adslAturPhysStruct.ifIndex= (*(int *)data_context);

  switch (var) {

        case COLUMN_ADSLATURCURRSNRMGN:
	   flags = ATUR_SNRMGN_FLAG;
	   break;

        case COLUMN_ADSLATURCURROUTPUTPWR:
	   flags = ATUR_CURR_OUT_PWR_FLAG;
	   break;

     	default:
     	   DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
     	   return NULL;
  	}
  
    SET_FLAG(&adslAturPhysStruct.flags, flags);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#else
    get_adslAturPhysTable1(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#endif
    if (IS_FLAG_SET(&adslAturPhysStruct.flags, flags) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "PhysTable: GET- %x CMV fail\n", flags));
    
    switch (flags)  {
	    
	case ATUR_SNRMGN_FLAG:
    	   long_ret = adslAturPhysStruct.SnrMgn;
	   break;

	case ATUR_CURR_OUT_PWR_FLAG:
    	   long_ret = adslAturPhysStruct.outputPwr;
	   break;

        default:
     	   DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
           return NULL;
	}

    CLR_FLAG(&adslAturPhysStruct.flags, flags);
    *ret_len = sizeof(int);
    return (int *) &long_ret;
}


u_int32 *
get_adslAturCurrAtnAttainableRate(void *data_context, size_t *ret_len,
				unsigned int var)
{
  unsigned int flags = 0;
  struct adslAturPhysEntry adslAturPhysStruct;
  memset(&adslAturPhysStruct,0,sizeof(adslAturPhysEntry));
  adslAturPhysStruct.ifIndex= (*(int *)data_context);

  switch (var) {

        case COLUMN_ADSLATURCURRATN:
	   flags = ATUR_ATTN_FLAG;
	   break;

        case COLUMN_ADSLATURCURRATTAINABLERATE:
	   flags = ATUR_CURR_ATTR_FLAG;
	   break;

     	default:
     	   DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
     	   return NULL;
  	}
  
    SET_FLAG(&adslAturPhysStruct.flags, flags);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#else
    get_adslAturPhysTable1(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#endif
    if (IS_FLAG_SET(&adslAturPhysStruct.flags, flags) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "PhysTable: GET- %x CMV fail\n", flags));
    
    switch (flags)  {
	    
	case ATUR_ATTN_FLAG:
    	   long_ret = adslAturPhysStruct.Attn;
	   break;

	case ATUR_CURR_ATTR_FLAG:
    	   long_ret = adslAturPhysStruct.attainableRate;
	   break;

        default:
     	   DEBUGMSGTL(("Unknown MIB variable requested!", "\n"));
           return NULL;
	}

    CLR_FLAG(&adslAturPhysStruct.flags, flags);
    *ret_len = sizeof(u_int32);
    return (u_int32 *) &long_ret;
}

#else

/** XXX: return a data pointer to the data for the adslAturInvSerialNumber
 *  column and set ret_len to its proper size in bytes. */
char           *
get_adslAturInvSerialNumber(void *data_context, size_t * ret_len)
{
    struct adslAturPhysEntry adslAturPhysStruct;

    memset(&adslAturPhysStruct,0,sizeof(adslAturPhysEntry));
    adslAturPhysStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&adslAturPhysStruct.flags,ATUR_PHY_SER_NUM_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_PHY, (void *)&adslAturPhysStruct);
#else
    get_adslAturPhysTable1(Fd, GET_ADSL_ATUR_PHY,(void *)&adslAturPhysStruct);
#endif
    if (IS_FLAG_SET(&adslAturPhysStruct.flags, ATUR_PHY_SER_NUM_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "SerNum CMV fail\n"));

    CLR_FLAG(&adslAturPhysStruct.flags, ATUR_PHY_SER_NUM_FLAG);
    memset(sys_info,0,sizeof(sys_info));
    strcpy(sys_info,adslAturPhysStruct.serial_no);

    *ret_len = strlen(adslAturPhysStruct.serial_no);
    return (char *) sys_info;

}

/** XXX: return a data pointer to the data for the adslAturInvVendorID column
 *  and set ret_len to its proper size in bytes. */
char           *
get_adslAturInvVendorID(void *data_context, size_t * ret_len)
{
    struct adslAturPhysEntry adslAturPhysStruct;

    memset(&adslAturPhysStruct,0,sizeof(adslAturPhysEntry));
    adslAturPhysStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&adslAturPhysStruct.flags,ATUR_PHY_VENDOR_ID_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#else
    get_adslAturPhysTable1(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#endif
    if (IS_FLAG_SET(&adslAturPhysStruct.flags, ATUR_PHY_VENDOR_ID_FLAG) == 0)
       DEBUGMSGTL(("adslMIB-ATUR", "VendorID CMV fail\n"));
	    
    CLR_FLAG(&adslAturPhysStruct.flags, ATUR_PHY_VENDOR_ID_FLAG);
    memset(sys_info,0,sizeof(sys_info));
    strcpy(sys_info,adslAturPhysStruct.vendor_id);

    *ret_len = strlen(adslAturPhysStruct.vendor_id);
    return (char *) sys_info;

}

/** XXX: return a data pointer to the data for the adslAturInvVersionNumber
 *  column and set ret_len to its proper size in bytes. */
char           *
get_adslAturInvVersionNumber(void *data_context, size_t * ret_len)
{
    struct adslAturPhysEntry adslAturPhysStruct;

    memset(&adslAturPhysStruct,0,sizeof(adslAturPhysEntry));
    adslAturPhysStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&adslAturPhysStruct.flags,ATUR_PHY_VER_NUM_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#else
    get_adslAturPhysTable1(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#endif
    if (IS_FLAG_SET(&adslAturPhysStruct.flags, ATUR_PHY_VER_NUM_FLAG) == 0)
      DEBUGMSGTL(("adslMIB-ATUR", "VersionNum CMV fail\n"));
	    
    CLR_FLAG(&adslAturPhysStruct.flags, ATUR_PHY_VER_NUM_FLAG);
    memset(sys_info,0,sizeof(sys_info));
    strcpy(sys_info,adslAturPhysStruct.version_no);

    *ret_len = strlen(adslAturPhysStruct.version_no);
    return (char *) sys_info;

}

/** XXX: return a data pointer to the data for the adslAturCurrSnrMgn column
 *  and set ret_len to its proper size in bytes. */
int           *
get_adslAturCurrSnrMgn(void *data_context, size_t * ret_len)
{
    struct adslAturPhysEntry adslAturPhysStruct;

    memset(&adslAturPhysStruct,0,sizeof(adslAturPhysEntry));
    adslAturPhysStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&adslAturPhysStruct.flags, ATUR_SNRMGN_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#else
    get_adslAturPhysTable1(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#endif
    if (IS_FLAG_SET(&adslAturPhysStruct.flags, ATUR_SNRMGN_FLAG) == 0)
       DEBUGMSGTL(("adslMIB-ATUR", "CurrSNRMGN CMV fail\n"));

    CLR_FLAG(&adslAturPhysStruct.flags, ATUR_SNRMGN_FLAG);
    long_ret = adslAturPhysStruct.SnrMgn;
    *ret_len = sizeof(adslAturPhysStruct.SnrMgn);
    return (int *) &long_ret;
}

/** XXX: return a data pointer to the data for the adslAturCurrAtn column and
 *  set ret_len to its proper size in bytes. */
u_int32         *
get_adslAturCurrAtn(void *data_context, size_t * ret_len)
{
    struct adslAturPhysEntry adslAturPhysStruct;

    memset(&adslAturPhysStruct,0,sizeof(adslAturPhysEntry));
    adslAturPhysStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&adslAturPhysStruct.flags, ATUR_ATTN_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#else
    get_adslAturPhysTable1(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#endif
    if (IS_FLAG_SET(&adslAturPhysStruct.flags, ATUR_ATTN_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "CurrAttn CMV fail\n"));

    CLR_FLAG(&adslAturPhysStruct.flags, ATUR_ATTN_FLAG);
    long_ret = adslAturPhysStruct.Attn;
    *ret_len = sizeof(adslAturPhysStruct.Attn);
    return (u_int32 *) &long_ret;
}

/** XXX: return a data pointer to the data for the adslAturCurrOutputPwr column
 *  and set ret_len to its proper size in bytes. */
int           *
get_adslAturCurrOutputPwr(void *data_context, size_t * ret_len)
{
    struct adslAturPhysEntry adslAturPhysStruct;

    memset(&adslAturPhysStruct,0,sizeof(adslAturPhysEntry));
    adslAturPhysStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&adslAturPhysStruct.flags, ATUR_CURR_OUT_PWR_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#else
    get_adslAturPhysTable1(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#endif
    if (IS_FLAG_SET(&adslAturPhysStruct.flags, ATUR_CURR_OUT_PWR_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "CurrOutPwr CMV fail\n"));

    CLR_FLAG(&adslAturPhysStruct.flags, ATUR_CURR_OUT_PWR_FLAG);
    long_ret = adslAturPhysStruct.outputPwr;
    *ret_len = sizeof(adslAturPhysStruct.outputPwr);
    return (int *) &long_ret;
}

/** XXX: return a data pointer to the data for the adslAturCurrAttainableRate
 *  column and set ret_len to its proper size in bytes. */
u_int32         *
get_adslAturCurrAttainableRate(void *data_context, size_t * ret_len)
{
    struct adslAturPhysEntry adslAturPhysStruct;

    memset(&adslAturPhysStruct,0,sizeof(adslAturPhysEntry));
    adslAturPhysStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&adslAturPhysStruct.flags, ATUR_CURR_ATTR_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#else
    get_adslAturPhysTable1(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#endif
    if (IS_FLAG_SET(&adslAturPhysStruct.flags, ATUR_CURR_ATTR_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "CurrAttrRate CMV fail\n"));

    CLR_FLAG(&adslAturPhysStruct.flags, ATUR_CURR_ATTR_FLAG);
    long_ret = adslAturPhysStruct.attainableRate;
    *ret_len = sizeof(adslAturPhysStruct.attainableRate);
    return (u_int32 *) &long_ret;
}

#endif

/** XXX: return a data pointer to the data for the adslAturCurrStatus column
 *  and set ret_len to its proper size in bytes. */
u_int32           *
get_adslAturCurrStatus(void *data_context, size_t * ret_len)
{
    struct adslAturPhysEntry adslAturPhysStruct;

    memset(&adslAturPhysStruct,0,sizeof(adslAturPhysEntry));
    adslAturPhysStruct.ifIndex= (*(int *)data_context);
    SET_FLAG(&adslAturPhysStruct.flags, ATUR_CURR_STAT_FLAG);

#ifdef ENABLE_DRIVER_CALL
    adsl_ioctl(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#else
    get_adslAturPhysTable1(Fd, GET_ADSL_ATUR_PHY,(void *) &adslAturPhysStruct);
#endif
    if (IS_FLAG_SET(&adslAturPhysStruct.flags, ATUR_CURR_STAT_FLAG) == 0) 
       DEBUGMSGTL(("adslMIB-ATUR", "CurrStatus CMV fail\n"));

    CLR_FLAG(&adslAturPhysStruct.flags, ATUR_CURR_STAT_FLAG);
    long_ret = adslAturPhysStruct.status;
    *ret_len = sizeof(adslAturPhysStruct.status);
    return (u_int32 *) &long_ret;
}


#ifndef ENABLE_DRIVER_CALL
int get_adslAturPhysTable1(int Fd2, int GET_adsl_ATUR_PHY2,
            void *adslAturPhysTable)
{
    struct adslAturPhysEntry *adslAturPhysValue;
    unsigned char temp[12]="Get Value";
    adslAturPhysValue = (adslAturPhysEntry *)adslAturPhysTable;
    strcpy(adslAturPhysValue->serial_no,temp);
    strcpy(adslAturPhysValue->vendor_id,temp);
    strcpy(adslAturPhysValue->version_no,temp);
    adslAturPhysValue->SnrMgn = 300;
    adslAturPhysValue->Attn = 310;
    adslAturPhysValue->status = ADSLATURCURRSTATUS_LOSSOFSIGNAL;
    adslAturPhysValue->outputPwr=10;
    adslAturPhysValue->attainableRate=10;

    return 0;
}
#endif
