/* ============================================================================
 * Copyright (C) 2004 - Infineon Technologies AG.
 *
 * All rights reserved.
 * ============================================================================
 *
 * ============================================================================
 *
 * This document contains proprietary information belonging to Infineon
 * Technologies AG. Passing on and copying of this document, and communication
 * of its contents is not permitted without prior written authorisation.
 *
 * ============================================================================
 */

/* ===========================================================================
 *
 * File Name    : adslLineTable_access.h
 * Author       : Subbi
 * Date         : 17-Jun-2004
 *
 * ===========================================================================
 *
 * Project      : Amazon
 * Block        : ADSL-MIBs
 *
 * ===========================================================================
 * Contents: This file contains:
 *                 1) User-defined data structure for accessing adslLineTable
 *                 2) User-defined data access functions for data in table
 *                    adslLineTable
 *                 3) Column accessors functions
 *
 *
 * ===========================================================================
 * References: RFC 2662
 *
 */

/* ===========================================================================
 * Revision History:
 *
 * $Log$
 * ===========================================================================
 */

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.6 2003/09/11 22:48:49 rstory Exp $
 */

#ifndef ADSLLINETABLE_ACCESS_H
#define ADSLLINETABLE_ACCESS_H

/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
 */
#include <adslMIB/adslTable_access.h>

/*
 * ===========================================================================
 *                           USER-DEFINED DATA TYPES
 * ===========================================================================
 */

#ifdef STUB_IOCTL
/** User-defined data structure for accessing adslLineTable **/
typedef struct adslLineTableEntry {
    int ifIndex;
    int adslLineCode;
    u_char flags;
} adslLineTableEntry;
#endif

/*
 * ===========================================================================
 *                           FUNCTION PROTOTYPES
 * ===========================================================================
 */
/** User-defined data access functions for data in table adslLineTable */
/** row level accessors */
Netsnmp_First_Data_Point adslLineTable_get_first_data_point;
Netsnmp_Next_Data_Point adslLineTable_get_next_data_point;

/** column accessors */
int  *get_adslLineCoding(void *data_context, size_t * ret_len);

#ifndef ENABLE_DRIVER_CALL
int get_adslLineTable(int Fd2, int Adsl_Line_CODE,void *adslLineTable);
#endif

#endif                          /* ADSLLINETABLE_ACCESS_H */
