/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    This document contains proprietary information belonging to Infineon
 *    Technologies AG. Passing on and copying of this document, and communication
 *    of its contents is not permitted without prior written authorisation.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : INCA-IP
 *        Block   : IFX-IIP-VOIP-MIB
 *        Creator : Sharon Tseng
 *        File    : ifxJitBuffTable_access.c
 *        Abstract: 
 *                  
 *        Date    : 24-May-2005
 *        Ref. Doc: IIP-DFS.doc
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/

/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.access_functions.conf,v 1.9 2004/10/14 12:57:33 dts12 Exp $
 */
 
/*
 * ===========================================================================
 *                           INCLUDE FILES
 * ===========================================================================
*/
#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "ifxJitBuffTable_access.h"

/*
 * ===========================================================================
 *                          GLOBAL DEFINITIONS
 * ===========================================================================
*/
static VOIPJITBUFFCFG_S     stCfg[IFX_CM_MAX_ENDPTS];
static x_IFX_CM_Msg         g_xCmMsg;

netsnmp_variable_list *
ifxJitBuffTable_set_indexes(VOIPJITBUFFCFG_S *datainfo,
                            netsnmp_variable_list *put_index_data)
{
    /* printf("**** ifxJitBuffTable_set_indexes ****\n"); */
    netsnmp_variable_list   *vptr;

    /* endPointIdx */
    vptr = put_index_data;
    snmp_set_var_value(vptr, (u_char *) &datainfo->ulEndPointIdx,
                       sizeof(datainfo->ulEndPointIdx) );

    /* suUserName */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->cUserName,
                       strlen(datainfo->cUserName) );

    /* suDomainName */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->cDomainName,
                       strlen(datainfo->cDomainName) );

    /* jfIndex */
    vptr = vptr->next_variable;
    snmp_set_var_value(vptr, (u_char *) &datainfo->ulIndex ,
                       sizeof(datainfo->ulIndex) );

    return put_index_data;
}

void  *
ifxJitBuffTable_get_data(void)
{
    int             i = 0;
    float           fValue = 0;
    char            sValue[8];

    for ( i = 0; i < IFX_CM_MAX_ENDPTS; i++)
    {
        memset (&stCfg[i], 0x00, sizeof(VOIPJITBUFFCFG_S));
        memset (&g_xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

       	g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    	g_xCmMsg.ucInfoType = IFX_CM_SIP_CFG_USER;
    	g_xCmMsg.ucChannel = i;
    
        if (IFX_CM_RecvDataFromCM (&g_xCmMsg) != IFX_CM_SUCCESS)
        {
            snmp_log(LOG_ERR,"ifxJitBuffTable: Fail to receive data from CM\n");
        }

        stCfg[i].ulEndPointIdx = g_xCmMsg.ucChannel;
        strncpy (stCfg[i].cUserName,
                 g_xCmMsg.uxData.xSipUserCfg.acUserName,
                 strlen(g_xCmMsg.uxData.xSipUserCfg.acUserName));
        strncpy (stCfg[i].cDomainName,
                 g_xCmMsg.uxData.xSipUserCfg.acDomain,
                 strlen(g_xCmMsg.uxData.xSipUserCfg.acDomain));

      	g_xCmMsg.ucMsgType = IFX_CM_GET_REQ;
    	g_xCmMsg.ucInfoType = IFX_CM_SIP_CFG_JITTERBUFF;
    	g_xCmMsg.ucChannel = i;
    
        if (IFX_CM_RecvDataFromCM (&g_xCmMsg) != IFX_CM_SUCCESS)
        {
            snmp_log(LOG_ERR,"ifxJitBuffTable: Fail to receive data from CM\n");
        }

        stCfg[i].ulIndex = i;
        stCfg[i].ulType = g_xCmMsg.uxData.xJbConfig.ucType;
        fValue = (float) (((float) (unsigned char) g_xCmMsg.uxData.xJbConfig.
                 ucScalingFactor) / 16);
        memset (sValue, 0x00, 8);
        sprintf (sValue, "%.4f", fValue);
        strcpy ( stCfg[i].cScalFactor, sValue);
        stCfg[i].ulInitSize = g_xCmMsg.uxData.xJbConfig.unInitialSize / 8;
        stCfg[i].ulMaxSize = g_xCmMsg.uxData.xJbConfig.unMaxSize / 8;
        stCfg[i].ulMinSize = g_xCmMsg.uxData.xJbConfig.unMinSize / 8;
    }
}

/** returns the first data point within the ifxJitBuffTable table data.

    Set the my_loop_context variable to the first data point structure
    of your choice (from which you can find the next one).  This could
    be anything from the first node in a linked list, to an integer
    pointer containing the beginning of an array variable.

    Set the my_data_context variable to something to be returned to
    you later that will provide you with the data to return in a given
    row.  This could be the same pointer as what my_loop_context is
    set to, or something different.

    The put_index_data variable contains a list of snmp variable
    bindings, one for each index in your table.  Set the values of
    each appropriately according to the data matching the first row
    and return the put_index_data variable at the end of the function.
*/
netsnmp_variable_list *
ifxJitBuffTable_get_first_data_point(void **my_loop_context,
                                     void **my_data_context,
                                     netsnmp_variable_list *
                                     put_index_data,
                                     netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxJitBuffTable_get_first_data_point ****\n"); */
    int     *position;

    /* we could do this with a file-static variable, but for learning
       purposes we'll use memory allocation to demonstrate simplistic
       freeing of a loop_context */
    position = (int *)malloc(sizeof(int));
    if (!position)
        return NULL;

    ifxJitBuffTable_get_data();

    /* We use the positinonal count as our loop context */
    *position = 0;
    *my_loop_context = position;

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = &stCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxJitBuffTable_set_indexes(&stCfg[*position], put_index_data);
}

/** functionally the same as ifxJitBuffTable_get_first_data_point, but
   my_loop_context has already been set to a previous value and should
   be updated to the next in the list.  For example, if it was a
   linked list, you might want to cast it to your local data type and
   then return my_loop_context->next.  The my_data_context pointer
   should be set to something you need later and the indexes in
   put_index_data updated again. */
netsnmp_variable_list *
ifxJitBuffTable_get_next_data_point(void **my_loop_context,
                                    void **my_data_context,
                                    netsnmp_variable_list * put_index_data,
                                    netsnmp_iterator_info *mydata)
{
    /* printf("**** ifxJitBuffTable_get_next_data_point ****\n"); */
    int *position = (int *) *my_loop_context;

    /* make sure we were called correctly */
    if (!position)
        return NULL;
    
    /* go to the next entry in the list */
    (*position)++;

    /* Are we beyond the end? */
    if (*position >= IFX_CM_MAX_ENDPTS)
    {
        /* End of entry.  stop here by returning NULL */
        free(position);
        *my_loop_context = NULL;
        *my_data_context = NULL;
        return NULL;
    }

    /* our data context is the individual array element, in this case
       it's the first. */
    *my_data_context = &stCfg[*position];

    /* now, save the index data into the passed in (linked list) pointer */
    return ifxJitBuffTable_set_indexes(&stCfg[*position], put_index_data);
}

/** Create a data_context for non-existent rows that SETs are performed on.
 *  return a void * pointer which will be passed to subsequent get_XXX
 *  and set_XXX functions for data retrival and modification during
 *  this SET request.
 *
 *  The indexes are encoded (in order) into the index_data pointer,
 *  and the column object which triggered the row creation is available
 *  via the column parameter, if it would be helpful to use that information.
 */
void           *
ifxJitBuffTable_create_data_context(netsnmp_variable_list * index_data,
                                    int column)
{
    return NULL;                /* XXX: you likely want to return a real pointer */
}

/** If the implemented set_* functions don't operate directly on the
   real-live data (which is actually recommended), then this function
   can be used to take a given my_data_context pointer and "commit" it
   to whereever the modified data needs to be put back to.  For
   example, if this was a routing table you could publish the modified
   routes back into the kernel at this point.

   new_or_del will be set to 1 if new, or -1 if it should be deleted
   or 0 if it is just a modification of an existing row.

   If you free the data yourself, make sure to *my_data_context = NULL */
int
ifxJitBuffTable_commit_row(void **my_data_context, int new_or_del)
{
    VOIPJITBUFFCFG_S      *datactx = *my_data_context;
    int                   i = 0;

    /* printf("**** ifxJitBuffTable_commit_row ****\n"); */

    if (new_or_del == -1)
    {
        return SNMP_ERR_NOERROR; /* no change in the value */
    }

    for ( i = 0; i < IFX_CM_MAX_ENDPTS; i++)
    {
        if (i == datactx->ulIndex)
        {
            memset (&g_xCmMsg, 0x00, sizeof(x_IFX_CM_Msg));

           	g_xCmMsg.ucMsgType = IFX_CM_SET_REQ;
        	g_xCmMsg.ucInfoType = IFX_CM_SIP_CFG_JITTERBUFF;
        	g_xCmMsg.ucChannel = i;
            g_xCmMsg.uxData.xJbConfig.ucType = datactx->ulType;
            strcpy (g_xCmMsg.uxData.xJbConfig.ucScalingFactor,
                    datactx->cScalFactor);
            g_xCmMsg.uxData.xJbConfig.unInitialSize = datactx->ulInitSize;
            g_xCmMsg.uxData.xJbConfig.unMaxSize = datactx->ulMaxSize;
            g_xCmMsg.uxData.xJbConfig.unMinSize = datactx->ulMinSize;

            if (IFX_CM_SendDataToCM (&g_xCmMsg) != IFX_CM_SUCCESS)
            {
                snmp_log(LOG_ERR, "ifxJitBuffTable: Fail to send RM-Codec data to CM");
                return SNMP_ERR_COMMITFAILED;
            }
        }
    }

    /*
     * return no errors.  And there shouldn't be any!!!  Ever!!!  You
     * should have checked the values long before this. 
     */
    return SNMP_ERR_NOERROR;
}


/*
 * User-defined data access functions (per column) for data in table ifxJitBuffTable 
 */
/*
 * NOTE:
 * - these get_ routines MUST return data that will not be freed (ie,
 *   use static variables or persistent data).  It will be copied, if
 *   needed, immediately after the get_ routine has been called.
 * - these SET routines must copy the incoming data and can not take
 *   ownership of the memory passed in by the val pointer.
 */
/** XXX: return a data pointer to the data for the jfType column and set
         ret_len to its proper size in bytes. */
u_long         *
get_jfType(void *data_context, size_t * ret_len)
{
    VOIPJITBUFFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulType);
    return &datainfo->ulType;
}

/** XXX: Set the value of the jfType column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_jfType(void *data_context, u_long * val, size_t val_len)
{
    VOIPJITBUFFCFG_S *datainfo = data_context;
    datainfo->ulType = IFX_CM_JB_ADAPTIVE;
    memcpy(&datainfo->ulType, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the jfScalFactor column and set
         ret_len to its proper size in bytes. */
char           *
get_jfScalFactor(void *data_context, size_t * ret_len)
{
    VOIPJITBUFFCFG_S   *datainfo = data_context;
	*ret_len = strlen(datainfo->cScalFactor);
    return (char *) &datainfo->cScalFactor;
}

/** XXX: Set the value of the jfScalFactor column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_jfScalFactor(void *data_context, char * val, size_t val_len)
{
    VOIPJITBUFFCFG_S *datainfo = data_context;
    float            fValue = 0;
    fValue = ((atof(datainfo->cScalFactor) * 16) + 0.5);
    memset (datainfo->cScalFactor, 0x00, 8);
    sprintf(datainfo->cScalFactor, "%.4f", fValue);
    memcpy(&datainfo->cScalFactor, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the jfInitSize column and set
         ret_len to its proper size in bytes. */
u_long         *
get_jfInitSize(void *data_context, size_t * ret_len)
{
    VOIPJITBUFFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulInitSize);
    return &datainfo->ulInitSize;
}

/** XXX: Set the value of the jfInitSize column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_jfInitSize(void *data_context, u_long * val, size_t val_len)
{
    VOIPJITBUFFCFG_S *datainfo = data_context;
    datainfo->ulInitSize = datainfo->ulInitSize * 8;
    memcpy(&datainfo->ulInitSize, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the jfMaxSize column and set
         ret_len to its proper size in bytes. */
u_long         *
get_jfMaxSize(void *data_context, size_t * ret_len)
{
    VOIPJITBUFFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulMaxSize);
    return &datainfo->ulMaxSize;
}

/** XXX: Set the value of the jfMaxSize column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_jfMaxSize(void *data_context, u_long * val, size_t val_len)
{
    VOIPJITBUFFCFG_S *datainfo = data_context;
    datainfo->ulMaxSize = datainfo->ulMaxSize * 8;
    memcpy(&datainfo->ulMaxSize, val, val_len);
    return SNMP_ERR_NOERROR;
}

/** XXX: return a data pointer to the data for the jfMinSize column and set
         ret_len to its proper size in bytes. */
u_long         *
get_jfMinSize(void *data_context, size_t * ret_len)
{
    VOIPJITBUFFCFG_S   *datainfo = data_context;
	*ret_len = sizeof(datainfo->ulMinSize);
    return &datainfo->ulMinSize;
}

/** XXX: Set the value of the jfMinSize column and return
         SNMP_ERR_NOERROR on success
         SNMP_ERR_XXX     for SNMP deterministic error codes
         SNMP_ERR_GENERR  on generic failures (a last result response). */
int
set_jfMinSize(void *data_context, u_long * val, size_t val_len)
{
    VOIPJITBUFFCFG_S *datainfo = data_context;
    datainfo->ulMinSize = datainfo->ulMinSize * 8;
    memcpy(&datainfo->ulMinSize, val, val_len);
    return SNMP_ERR_NOERROR;
}
